
#include "AppEvent.Ch"
#include "DcBitMap.Ch"
#include "DcDialog.Ch"
#include "DcGra.Ch"
#include "Inkey.Ch"
#include "Xbp.Ch"

#define VK_NUMLOCK        0x90
#define VK_SCROLL         0x91
#define VK_CAPITAL        0x14
#define APPKEY_PRESSED    2

PROCEDURE Main

  LOCAL GetList := {}, GetOptions, oGroup, lStatus, oStatBar, oMsgStatic, oInsStatic, oNumStatic, oCapsStatic, oMsgBox

  DC_Gui(.t.)
  DC_SetKeyActive(.t.)
  DC_GetPopupCaption({ '12.Arial Bold', BITMAP_SCAN_M, 0 })
  DC_GetPopupAutoHide(.t.)

  bRefresh := {|| DC_GetRefresh(GetList) }

  cBitMap  := "MV Citation.Jpg"
  bBitMap  := {|| cBitMap }

  @   .00,  .50 DCGROUP oGroup1        CAPTION ' Municipality Information '                   SIZE 150.00,25.00                                                               COLOR GRA_CLR_BLUE,GRA_CLR_BACKGROUND

  @  1.00, 1.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX                                      SIZE 148.00,23.50                                           PARENT oGroup1      OBJECT oCitation

  DCBITMAP {|| cBitMap }                                                                                                                                  PARENT oCitation    AUTOSCALE CENTER




  @ 25.75, 2.00 DCPUSHBUTTON          CAPTION 'Draw'                                          SIZE  9, 1.25 ;
                CARGO 'CANCEL' ;
                ACTION {|| DC_BitMapDraw(oCitation, cBitMap), DC_GetRefresh(GetList) }

  @ 25.75,13.00 DCPUSHBUTTON          CAPTION 'ReFresh'                                       SIZE  9, 1.25 ;
                CARGO 'CANCEL' ;
                ACTION {|| DC_GetRefresh(GetList) }

  @ 25.75,24.00 DCPUSHBUTTON          CAPTION 'Exit'                                          SIZE  9, 1.25 ;
                CARGO 'CANCEL' ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }



  DCSTATUSBAR oStatBar  HEIGHT 25  ALIGN DCGUI_ALIGN_BOTTOM  SPACING 0

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			  OBJECT oMsgStatic         SIZE 300,20 			          PIXEL                         PARENT oStatBar

  @  2.00, 2.00 DCMESSAGEBOX TYPE XBPSTATIC_TYPE_TEXT               OBJECT oMsgBox            SIZE 300,20                   PIXEL                         PARENT oMsgStatic  COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			  OBJECT oCapsStatic        SIZE 30,20                    PIXEL                         PARENT oStatBar

  @  1.00, 1.00 DCSAY ''                                            ID 'CAPSLOCK' 			    SAYSIZE 28,18     SAYCENTER   PIXEL                         PARENT oCapsStatic

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			  OBJECT oNumStatic         SIZE 30,20                    PIXEL                         PARENT oStatBar

  @  1.00, 1.00 DCSAY ''                                            ID 'NUMLOCK' 			    SAYSIZE 28,18     SAYCENTER   PIXEL                         PARENT oNumStatic

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			  OBJECT oInsStatic         SIZE 30,20                    PIXEL                         PARENT oStatBar

  @  1.00, 1.00 DCSAY ''                                            ID 'INSERT' 			       SAYSIZE 28,18     SAYCENTER   PIXEL                         PARENT oInsStatic

  DCHOTKEY K_INS ACTION {|| ReadInsert(!ReadInsert()) }


  DCGETOPTIONS ;
    CASCADE ;
	 AUTORESIZE ;
    SOURCEFILE __FILEPATH__


  DCREAD GUI ;
         FIT ;
			MODAL ;
         OPTIONS GetOptions ;
         TITLE 'Prepare Citation' ;
			EVAL {|o| SetTimerEvent(100,{|| _UpdateStats(GetList)}) }

	SetTimerEvent(0)

RETURN

*---

STATIC FUNCTION _UpdateStats( GetList )

  LOCAL oCapsLock := DC_GetObject(GetList,'CAPSLOCK')
  LOCAL oNumLock  := DC_GetObject(GetList,'NUMLOCK')
  LOCAL oInsert   := DC_GetObject(GetList,'INSERT')
  LOCAL lCaps     := AppKeyState( VK_CAPITAL,.t. )
  LOCAL lNum      := AppKeyState( VK_NUMLOCK,.t. )

  IF lNum == APPKEY_PRESSED
    oNumLock:SetCaption( "Num" )
  ELSE
    oNumLock:SetCaption( "" )
  ENDIF

  IF lCaps == APPKEY_PRESSED
    oCapsLock:SetCaption( "Caps" )
  ELSE
    oCapsLock:SetCaption( "" )
  ENDIF

  IF ReadInsert()
    oInsert:SetCaption( "Ins" )
  ELSE
    oInsert:SetCaption( "Ovr" )
  ENDIF

RETURN Nil
